#!usr/bin/env python3

import sqlite3
from glob import glob
from os.path import dirname

DbDirectory = dirname(__file__).split('/M')[0] + '/SetupInterface/database/Settings.db'
OneWireDirectory = '/sys/bus/w1/devices/'
DevicesDirectories = glob(OneWireDirectory + '28*')
IDs = [ID.split('devices/')[1] for ID in DevicesDirectories]
db = sqlite3.connect(DbDirectory)
db.execute("DELETE FROM W1")
for Sensor in range(len(IDs)):
	db.execute("INSERT INTO W1 VALUES (?, ?)", (Sensor + 1, IDs[Sensor]))
db.commit()
db.close()
print("List of ID from DS18B20 successfully updated")
