function InvalidThingSpeakName(TextBox, Missing, TooLong) {

    if (TextBox.validity.valueMissing) {
        TextBox.setCustomValidity(Missing);
    } else if (TextBox.validity.tooLong) {
        TextBox.setCustomValidity(TooLong);
    } else {
        TextBox.setCustomValidity('');
    }

    input.reportValidity();
}

function InvalidThingSpeakID(TextBox, Missing, TooShort, TooLong) {

    if (TextBox.validity.valueMissing) {
        TextBox.setCustomValidity(Missing);
    } else if (TextBox.validity.tooShort) {
        TextBox.setCustomValidity(TooShort);
    } else if (TextBox.validity.tooLong) {
        TextBox.setCustomValidity(TooLong);
    } else {
        TextBox.setCustomValidity('');
    }

    input.reportValidity();
}

function InvalidThingSpeakWriteAPIKey(TextBox, Missing, TooShort, TooLong) {

    if (TextBox.validity.valueMissing) {
        TextBox.setCustomValidity(Missing);
    } else if (TextBox.validity.tooShort) {
        TextBox.setCustomValidity(TooShort);
    } else if (TextBox.validity.tooLong) {
        TextBox.setCustomValidity(TooLong);
    } else {
        TextBox.setCustomValidity('');
    }

    input.reportValidity();
}

function InvalidOffset(TextBox, BadInput, RangeUnderflow, RangeOverflow, StepMismatch) {

    if (TextBox.validity.badInput) {
        TextBox.setCustomValidity(BadInput);
    } else if (TextBox.validity.rangeUnderflow) {
        TextBox.setCustomValidity(RangeUnderflow);
    } else if (TextBox.validity.rangeOverflow) {
        TextBox.setCustomValidity(RangeOverflow);
    } else if (TextBox.validity.stepMismatch) {
        TextBox.setCustomValidity(StepMismatch);
    } else {
        TextBox.setCustomValidity('');
    }

    input.reportValidity();
}

function InvalidScale(TextBox, BadInput, RangeUnderflow, RangeOverflow, StepMismatch) {

    if (TextBox.validity.badInput) {
        TextBox.setCustomValidity(BadInput);
    } else if (TextBox.validity.rangeUnderflow) {
        TextBox.setCustomValidity(RangeUnderflow);
    } else if (TextBox.validity.rangeOverflow) {
        TextBox.setCustomValidity(RangeOverflow);
    } else if (TextBox.validity.stepMismatch) {
        TextBox.setCustomValidity(StepMismatch);
    } else {
        TextBox.setCustomValidity('');
    }

    input.reportValidity();
}

function InvalidReference(TextBox, BadInput, RangeUnderflow, RangeOverflow, StepMismatch) {

    if (TextBox.validity.badInput) {
        TextBox.setCustomValidity(BadInput);
    } else if (TextBox.validity.rangeUnderflow) {
        TextBox.setCustomValidity(RangeUnderflow);
    } else if (TextBox.validity.rangeOverflow) {
        TextBox.setCustomValidity(RangeOverflow);
    } else if (TextBox.validity.stepMismatch) {
        TextBox.setCustomValidity(StepMismatch);
    } else {
        TextBox.setCustomValidity('');
    }

    input.reportValidity();
}

function InvalidCorrection(TextBox, BadInput, RangeUnderflow, RangeOverflow, StepMismatch) {

    if (TextBox.validity.badInput) {
        TextBox.setCustomValidity(BadInput);
    } else if (TextBox.validity.rangeUnderflow) {
        TextBox.setCustomValidity(RangeUnderflow);
    } else if (TextBox.validity.rangeOverflow) {
        TextBox.setCustomValidity(RangeOverflow);
    } else if (TextBox.validity.stepMismatch) {
        TextBox.setCustomValidity(StepMismatch);
    } else {
        TextBox.setCustomValidity('');
    }

    input.reportValidity();
}

function ValidateFile(File, Type, AlertID, LabelID, WrongType, TooBig) {

    if (File.name.split(".").slice(-1) != Type) {
        alertPlaceholder = document.getElementById(AlertID)
        wrapper = document.createElement('div')
        wrapper.innerHTML = [
            `<div class="alert alert-danger alert-dismissible" role="alert">`,
            `   <div>'${WrongType}'</div>`,
            '   <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>',
            '</div>'
        ].join('')
        alertPlaceholder.append(wrapper)
    } else if (File.size > 10 * 1048576) {
        alertPlaceholder = document.getElementById(AlertID)
        wrapper = document.createElement('div')
        wrapper.innerHTML = [
            `<div class="alert alert-danger alert-dismissible" role="alert">`,
            `   <div>'${TooBig}'</div>`,
            '   <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>',
            '</div>'
        ].join('')
        alertPlaceholder.append(wrapper)
    } else {
        label = document.getElementById(LabelID);
        label.textContent = File.name;
    }
}